local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database

-------------------------------------------------------------------------------
-- Bindings
-------------------------------------------------------------------------------

BINDING_HEADER_SIXUI = "SixUI"
BINDING_NAME_SIXUI_TELLTARGET = "Tell Target"
BINDING_NAME_SIXUI_NOTHING_1 = "Nothing 1"
BINDING_NAME_SIXUI_NOTHING_2 = "Nothing 2"
BINDING_NAME_SIXUI_NOTHING_3 = "Nothing 3"
BINDING_NAME_SIXUI_NOTHING_4 = "Nothing 4"
BINDING_NAME_SIXUI_NOTHING_5 = "Nothing 5"

-------------------------------------------------------------------------------
-- Dialogs
-------------------------------------------------------------------------------

StaticPopupDialogs["SIXUI_SET_BROADCAST"] = {
	preferredIndex = STATICPOPUP_NUMDIALOGS,
	text = BATTLENET_BROADCAST,
	button1 = UPDATE,
	button2 = CANCEL,
	hasEditBox = true,
	maxLetters = 127,
	countInvisibleLetters = true,
	editBoxWidth = 350,
	OnAccept = function (self)
		if self.editBox:GetText() ~= select(4, BNGetInfo()) then
			BNSetCustomMessage(self.editBox:GetText())
		end
	end,
	OnShow = function (self)
		self.editBox:SetText(select(4, BNGetInfo()))
		self.editBox:SetFocus()
	end,
	EditBoxOnEnterPressed = function (self)
		if self:GetText() ~= select(4, BNGetInfo()) then
			BNSetCustomMessage(self:GetText())
		end

		self:GetParent():Hide()
	end,
	EditBoxOnEscapePressed = function (self)
		self:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = true,
	whileDead = true,
	hideOnEscape = true,
}

StaticPopupDialogs["SET_BNFRIENDNOTE"].preferredIndex = STATICPOPUP_NUMDIALOGS

-------------------------------------------------------------------------------
-- Helpers
-------------------------------------------------------------------------------

function GetMinimapShape()
	return "SQUARE"
end

function SixUI_GetLayout()
	return A:GetActiveLayout()
end

function SixUI_IsClutterKeyDown()
	return C.CLUTTER_KEY_FUNCTION()
end

function SixUI_ToggleOptionsFrame()
	local CoreConfig = A:GetModule("Core Config")

	if CoreConfig then
		CoreConfig.ToggleOptionsFrame()
	else
		A.PrintF("The AddOn '%s' isn't loaded.", A.Highlight("SixUI Config"))
	end
end

function SixUI_ToggleSetupFrame()
	local CoreConfig = A:GetModule("Core Config")

	if CoreConfig then
		CoreConfig.ToggleSetupFrame()
	else
		A.PrintF("The AddOn '%s' isn't loaded.", A.Highlight("SixUI Config"))
	end
end
