
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: DoEmote, UnitIsDeadOrGhost

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local M = A:NewModule("Automation Emote")

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

function M:OnEnable()
	self:RegisterEvent("RESURRECT_REQUEST", "SetInviter")
	self:CreateHook("SecureHook", "AcceptResurrect", "ScheduleThankInviter")
	self:CreateHook("SecureHook", "DeclineResurrect", "ClearInviter")
	self:CreateHook("SecureHook", "TimeoutResurrect", "ClearInviter")
end

function M:SetInviter(event, inviter)
	self.inviter = inviter
end

function M:ClearInviter()
	self.inviter = nil
end

function M:ThankInviter(inviter)
	if not UnitIsDeadOrGhost("player") then
		DoEmote("thank", inviter)
	end
end

function M:ScheduleThankInviter()
	if self.inviter then
		self:ScheduleTimer("ThankInviter", 1, self.inviter)
		self:ClearInviter()
	end
end
