local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database

local M = A:NewModule("Blizzard Miscellaneous")

function A.IsGuildAchievement(achievementID)
	return select(12, GetAchievementInfo(achievementID))
end

function M:OnEnable()
	self:CreateHook("RawHook", AchievementAlertSystem, "AddAlert", "OnAchievementAlertSystemAddAlert", true)
	self:RegisterFrames()
	self:UpdateDefaultPanelPosition()
end

function M:RegisterFrames()
	A:GetFrameConfig("FloatingBattlePetTooltip"):ClearAllPoints():SetPoint("TOPLEFT", "SixUI_TooltipAnchor", "TOPLEFT")
	A:GetFrameConfig("FloatingGarrisonFollowerAbilityTooltip"):ClearAllPoints():SetPoint("TOPLEFT", "SixUI_TooltipAnchor", "TOPLEFT")
	A:GetFrameConfig("FloatingGarrisonFollowerTooltip"):ClearAllPoints():SetPoint("TOPLEFT", "SixUI_TooltipAnchor", "TOPLEFT")
	A:GetFrameConfig("FloatingGarrisonMissionTooltip"):ClearAllPoints():SetPoint("TOPLEFT", "SixUI_TooltipAnchor", "TOPLEFT")
	A:GetFrameConfig("FloatingGarrisonShipyardFollowerTooltip"):ClearAllPoints():SetPoint("TOPLEFT", "SixUI_TooltipAnchor", "TOPLEFT")
	A:GetFrameConfig("FloatingPetBattleAbilityTooltip"):ClearAllPoints():SetPoint("TOPLEFT", "SixUI_TooltipAnchor", "TOPLEFT")
	A:GetFrameConfig("ItemRefTooltip"):ClearAllPoints():SetPoint("TOPLEFT", "SixUI_TooltipAnchor", "TOPLEFT")
	A:GetFrameConfig("StatusTrackingBarManager"):SetShown(false)
	A:GetFrameConfig("TalkingHeadFrame"):SetScale(0.8)
	A:GetFrameConfig("ExtraAbilityContainer"):SetScale(0.8):Run(function (frame) frame:SetClampedToScreen(false) end)
end

function M:UpdateDefaultPanelPosition()
	UIParent:SetAttribute("TOP_OFFSET", -250)
	UIParent:SetAttribute("LEFT_OFFSET", 20)
end

-- Use a hook to prevent guild achievements from being added to the achievement alert system.
function M:OnAchievementAlertSystemAddAlert(AchievementAlertSystem, ...)
	if not self.IsGuildAchievement(...) then
		self.hooks[AchievementAlertSystem].AddAlert(AchievementAlertSystem, ...)
	end
end
