
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: IsAltKeyDown, strsplit, tonumber

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local M = A:NewModule("Chat Invite")
local L = LibStub("SixSocial-1.0")

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

M.LinkType = {
	battleTag = true,
	BNplayer = true,
	player = true,
}

function M:OnEnable()
	self:CreateHook("SecureHook", "SetItemRef")
end

-------------------------------------------------------------------------------
-- Hooks
-------------------------------------------------------------------------------

function M:SetItemRef(link)
	if not IsAltKeyDown() then return end
	local type, arg1, arg2 = strsplit(":", link)
	if not self.LinkType[type] then return end
	local friend = (type == "battleTag" and L:GetFriendByBattleTag(arg1))
		or (type == "BNplayer" and L:GetFriendByAccountID(tonumber(arg2)))
		or (type == "player" and L:WrapUnitInFriend(arg1))

	if friend then
		friend:SendInvite()
	end

	A.CloseEditBox()
end
