
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: ChatFrame1, coroutine, next

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local M = A:NewModule("Integration BadBoy"):WithDependency("BadBoy")

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

function M.IterateButtons()
	return coroutine.wrap(function ()
		for _, frame in next, {ChatFrame1:GetChildren()} do
			if frame:IsObjectType("Frame") and frame:GetFrameStrata() == "DIALOG" then
				coroutine.yield(frame)
			end
		end
	end)
end

function M:OnEnable()
	self:StyleAllButtons()
end

function M:OnDisable()
	self:ResetAllButtons()
end

function M:StyleAllButtons()
	for button in self.IterateButtons() do
		self:StyleButton(button)
	end
end

function M:ResetAllButtons()
	for button in self.IterateButtons() do
		self:ResetButton(button)
	end
end

function M:StyleButton(button)
	A:GetFrameConfig(button):SetShown(false)
end

function M:ResetButton(button)
	A:GetFrameConfig(button):ResetAll()
end
